#!/bin/bash

# Make sure only root can run our script
if [[ $EUID -ne 0 ]]; then
   echo "This script must be run as root" 1>&2
   exit 1
fi

if [ ! -d /usr/avr/rk ]; then
  sudo mkdir /usr/avr/include/rk
fi

cp src/* /usr/avr/rk/

echo Done
