#pragma once

#ifndef _EXTERNAL_INTERRUPT_H_
#define _EXTERNAL_INTERRUPT_H_

#if defined (__AVR_ATmega8__) || (__AVR_ATmega8A__)
#	include "external_interrupt/ext_irq_m8.h"
#elif defined (__AVR_ATmega16__) || (__AVR_ATmega16A__) || (__AVR_ATmega32__) || (__AVR_ATmega32A__)
#	include "external_interrupt/ext_irq_m32.h"
#elif defined (__AVR_ATmega128__) || (__AVR_ATmega128A__) || (__AVR_ATmega1281__)
# include "external_interrupt/ext_irq_m128.h"
#else
#	error "This lib don't support this device"
#endif

#endif
