#include <avr/io.h>
#include "usart.h"

int main()
{
    //Vytvoření objektu uart
    usart uart;

    //Nastavení uartu
    uart.set_operating_mode(ASYNCHRONOUS_NORMAL);
    uart.set_baudrate(4800);
    uart.set_data_bits(8);
    uart.set_stop_bits(1);
    uart.set_parity(PARITY_NONE);
    uart.enable_reciver(true);
    uart.enable_trasmitter(true);

    //Odeslání textového řetězce
    uart.transmit_string("\n\rHello world!\n\r");

    char znak;

    for(;;)
    {
        //Přijmi znak
        znak = uart.receive_char();

        //Odešli znak zpátky
        uart.transmit_char(znak);
    }
}