
#include "jtag.h"

#include <avr/io.h>
#include <stdint.h>


extern void jtag::disable_jtag(void)
{
#if defined(__AVR_ATmega1281__)
	MCUSR = (1<<JTD);
	MCUSR = (1<<JTD);
#else
	#ifndef __AVR_ATmega8__
		MCUCSR = (1<<JTD);
		MCUCSR = (1<<JTD);
    #endif
#endif
}

extern void jtag::enable_jtag(void)
{
#if defined(__AVR_ATmega1281__)
    MCUSR = (1<<JTD);
    MCUSR = (1<<JTD);
#else
    #ifndef __AVR_ATmega8__
		MCUCSR = 0;
		MCUCSR = 0;
    #endif
#endif
}


